package calendar;

public class GregorianCalender {

	public static boolean isLeapYear(int year) {
		return year % 4 == 0 && year % 100 != 0 || year % 400 == 0;
	}

	public static int getNumberOfDaysSwitch(int month, int year) {
		if (year < 1) {
			return -1;
		}
		switch (month) {
		case 1:
		case 3:
		case 5:
		case 7:
		case 10:
		case 12:
			return 31;
		case 4:
		case 6:
		case 9:
		case 11:
			return 30;
		case 2:
			return isLeapYear(year) ? 29 : 28;
		default:
			return -1;
		}
	}

	public static int getNumberOfDays(int month, int year) {
		int days = -1;
		if (year >= 1) {
			if (month == 1 || month == 3 || month == 5 || month == 7
					|| month == 10 || month == 12) {
				days = 31;
			} else if (month == 4 || month == 6 || month == 9 || month == 11) {
				days = 30;
			} else if (month == 2) {
				if (isLeapYear(year)) {
					days = 29;
				} else {
					days = 28;
				}
			}
		}
		return days;
	}
}
