package embedded.explicit;

import test.IStateMachine;

public class StateMachine implements IStateMachine {
	private enum State {
		A, B, C, D, ENDE
	}

	private State s = State.A;

	private String path = "";

	public StateMachine() {
		path += s.toString();
	}

	public void x() {
		switch (s) {
		case A:
			s = State.C;
			entryC();
			break;
		case B:
			exitB();
			s = State.C;
			entryC();
			break;
		case C:
			s = State.D;
			break;
		case D:
			s = State.ENDE;
			break;
		default:
			throw new IllegalStateException();
		}
		path += s.toString();
	}

	public void y() {
		switch (s) {
		case A:
			s = State.B;
			entryB();
			break;
		case B:
			exitB();
			s = State.D;
			break;
		case D:
			s = State.C;
			entryC();
			break;
		default:
			throw new IllegalStateException();
		}
		path += s.toString();
	}

	private void entryB() {
	}

	private void exitB() {
	}

	private void entryC() {
	}

	@Override
	public String getPath() {
		return path;
	}

}
