/**
 * 
 */
package outsourced.explicit;

abstract class State {
	protected StateMachine m = null;

	protected State(StateMachine m) {
		this.m = m;
	}

	protected void entry() {
	}

	protected void exit() {
	}

	protected void x() {
		throw new IllegalStateException();
	}

	protected void y() {
		throw new IllegalStateException();
	}

	protected final void makeTransition() {
		State next = next();
		if (next != this) {
			this.exit();
			next.entry();
			m.setState(next);
		}
	}

	protected abstract State next();
}