package statetable;

import test.IStateMachine;

public class StateMachine implements IStateMachine {
	private static final int A = 0;
	private static final int B = 1;
	private static final int C = 2;
	private static final int D = 3;
	private static final int END = 4;
	private static final int ERROR = -1;

	private static final int X = 0;
	private static final int Y = 1;

	int[][] stateTable = new int[][] { { C, C, D, END, ERROR },
			{ B, D, ERROR, C, ERROR } };

	private int s = A;

	private String path = "";

	public StateMachine() {
		path += toString(s);
	}

	public void x() {
		makeTransition(X);
	}

	public void y() {
		makeTransition(Y);
	}

	private void makeTransition(int i) {
		s = stateTable[i][s];
		path += toString(s);
		if (s == ERROR) {
			throw new IllegalStateException();
		}
	}

	private String toString(int i) {
		switch (i) {
		case A:
			return "A";
		case B:
			return "B";
		case C:
			return "C";
		case D:
			return "D";
		case END:
			return "ENDE";
		case ERROR:
			return "FEHLER";
		default:
			return "MURKS";
		}
	}

	@Override
	public String getPath() {
		return path;
	}
}
